(module Syntax mzscheme
  (require (lib "class.ss"))
  (provide (all-from (lib "class.ss")) (all-defined))

(define-syntax tell
  (syntax-rules ()
    ([tell name ( exp ... ) ...]
     (send* name ( exp ... ) ...)
    )
    )
  )

(define-syntax tell1
  (syntax-rules ()
    ([tell1 obj msg ...]
     (send obj msg ...)
    )
    )
  )

(define-syntax tell/apply
  (syntax-rules ()
    ([tell/apply obj msg args]
     (send/apply obj msg args)
    )
    )
  )

(define-syntax new-tell
  (syntax-rules ()
    ([new-tell C msg ...]
     (let ([c (new C)])
       (tell c msg ...)
       c)
     )
    )
  )

(define-syntax object
  (syntax-rules ()
    ([object name type exp ...]
     (begin 
       (define name (new type))
       (tell name exp) ...
       name))))
)
